package com.anthonycicchetti.slackbot.utility

import com.fasterxml.jackson.annotation.JsonInclude
import com.fasterxml.jackson.databind.ObjectMapper
import com.slack.api.model.kotlin_extension.block.withBlocks
import java.text.NumberFormat

data class BlockResponse(val status: Int = 200, val itemName: String, val highVal: Int, val lowVal: Int) {
    val response: String
    init {
        val mapper = ObjectMapper()
        mapper.setSerializationInclusion(JsonInclude.Include.NON_NULL)
        val resp = run {
            withBlocks {
                section { markdownText("Item Found: ${itemName}") }
                divider()
                section { markdownText(":chart_with_upwards_trend:: ${NumberFormat.getNumberInstance().format(highVal)}") }
                section { markdownText(":chart_with_downwards_trend:: ${NumberFormat.getNumberInstance().format(lowVal)}") }
                divider()
                section { markdownText("<https://oldschool.runescape.wiki/?search=${itemName.replace(' ', '+')}&title=Special%3ASearch&go=Go|Wiki Search>")}
            }
        }
        response = mapper.writeValueAsString(resp)
    }
}

val notFoundItem = BlockResponse(200, "Item Not Found", 0, 0 )
